// groove receiver, version D (different files)
// make our patch, load our files, set sound stuff up
SndBuf s[9];  JCRev r => dac; 0.01 => r.mix;
["Silence.au","CowbellOpen.au","CowbellOpenB.au",
"CowbellClosed.au","CowbellClosedB.au","SheepBellOpen.au",
"SheepBellOpenB.au","SheepBellClosed.au","SheepBellClosedB.au"] @=> string myFiles[];
for( int i; i < s.cap(); i++ ) 
    { "GamelanSounds/"+myFiles[i] => s[i].read; s[i] => r; 0 => s[i].gain; }

OscRecv recv;      // create our OSC receiver
6449 => recv.port; // use port 6449
recv.listen();     // start listening (launch thread)
// create an address in the receiver, store in new variable
recv.event( "/plork/synch/clock, i i" ) @=> OscEvent oe;

8 => int width;
4 => int height;
int x; int y; int value;

MAUI_View MyWinder; MyWinder.name("New MiniAudicle Gamelan Controller!!"); 
MyWinder.size(660.0,500.0); MyWinder.display();
MAUI_Button butts[width][height+1]; 
for (0 => y; y < height; y++) { 
    for (0 => x; x < width; x++) {
        butts[x][y].size(100.0,110.0);
        butts[x][y].position(x*80.0,y*80.0);
        butts[x][y].toggleType();
        MyWinder.addElement(butts[x][y]);
    }
}
["111111\n111111\n111111\n111111","222222\n222222\n222222\n222222",
"333333\n333333\n333333\n333333","444444\n444444\n444444\n444444",
"555555\n555555\n555555\n555555","666666\n666666\n666666\n666666",
"777777\n777777\n777777\n777777","888888\n888888\n888888\n888888"] 
                           @=> string myButtNames[];
for (0 => x; x < width; x++) {
    butts[x][height].size(100.0,110.0);
    butts[x][height].position(x*80.0,400.0);
    butts[x][height].pushType();
    butts[x][height].name(myButtNames[x]);
    MyWinder.addElement(butts[x][height]);
}

MAUI_Button clearButt; clearButt.name("CLEAR   CLEAR   CLEAR");
clearButt.size(500,100); clearButt.position(0,320); clearButt.pushType();
MyWinder.addElement(clearButt);

MAUI_Button exitButt; exitButt.name("EXIT");
exitButt.size(100,100); exitButt.position(500,320); exitButt.pushType();
MyWinder.addElement(exitButt);

MAUI_Button sprite; sprite.size(90,100); 
sprite.toggleType(); sprite.state(1); MyWinder.addElement(sprite);

int buttvals[(width*height)+1];

int recx;
int recy;

1 => int notDone;

// infinite event loop
while ( notDone )
{
    oe => now;    // wait for event to arrive
    while( oe.nextMsg() != 0 )    // grab the next message from the queue. 
    {
        oe.getInt() => recx;         // get x and y
        oe.getInt() => recy;
        !exitButt.state() => notDone;
        for (0 => x; x < width; x++) {
            if (butts[x][4].state()) {
                x+1 => buttvals[recx+(recy*8)];
                1 => butts[recx][recy].state;
                butts[recx][recy].name(myButtNames[x]);
            }
        }
        if (clearButt.state()) {
            0 => butts[recx][recy].state;
            " " => butts[recx][recy].name;
            0 => buttvals[recx+(recy*8)];
        }
        sprite.position(recx*80.0+5.0,recy*80.0+5.0);
        play(buttvals[recx+(recy*8)]);
    }
}

MyWinder.destroy();

// do something musical
fun void play( int value )    {  
    [[1.0, 0.2, 0.3, 0.2, 0.4, 0.1, 0.2, 0.1],
    [0.5, 0.1, 0.3, 0.2, 0.4, 0.1, 0.2, 0.1],
    [0.8, 0.1, 0.3, 0.2, 0.5, 0.1, 0.2, 0.1],
    [0.4, 0.1, 0.3, 0.2, 0.3, 0.1, 0.2, 0.1]] @=> float mygains[][];
    float temp;

    if( value == 0 ) return;
    if (Std.rand2f(0.0,1.0) < mygains[recy][recx])	{
        // <<< "playing:", value >>>;
        0.2 + Std.rand2f(0.0,mygains[recy][recx]) => temp;
        temp => s[value].gain;
        0 => s[value].pos;
    }
}
